#!/bin/bash
VER=1.0
##############################################################
# IdleBotKick - Kick Idlers or a specific User               #
#------------------------------------------------------------#
# A small script for kicking all idlers, or a specific user. #
# This is done from irc, usally by @ only.                   #
#                                                            #
# Note, due to the nature of this script, it might not be    #
# the best idea to install it if you have untrusted shell    #
# users on the bot, since we must make kill run as root.     #
#                                                            #
# Running this with !kick only (default trigger) will kick   #
# everyone in the state of Idle. You may also do             #
# !kick username and it will kick only that user from site.  #
#                                                            #
#--[ Installation ]------------------------------------------#
# Copy idlebotkick.sh to /glftpd/bin                         #
# Copy idlebotkick.tcl to your bots "config" folder.         #
#  Edit idlebotkick.tcl to see some short instructions.      #
# Add idlebotkick.tcl to your bots config file and rehash it.#
#                                                            #
# This script uses tur-ftpwho to list idlers etc. Its just a #
# modified ftpwho binary. The binary included is compiled on #
# Mandrake, and should work for debian, redhat etc. If you   #
# must/would rather recompile your own, the source is        #
# included. ( gcc -o tur-ftpwho tur-ftpwho.c ).              #
# Copy tur-ftpwho to /glftpd/bin (same as for KTMF, so if    #
# you use that one already, you're fine.                     #
# Try running it from shell and it should show some info.    #
# Make sure it is executable by the user who runs the bot.   #
#  ( chmod 755 /glftpd/bin/tur-ftpwho )                      #
#  ( chmod 755 /glftpd/bin/idlebotkick.sh )                  #
#                                                            #
# Now for the insecure part. Copy /bin/kill to /glftpd/bin   #
# and rename it to something (default is killbin).           #
#  ( cp /bin/kill /glftpd/bin/killbin )                      #
#                                                            #
# Edit /etc/group and find "wheel". Add the user who runs    #
# the bot after root, like this:                             #
# wheel:x:10:root,UserWhoRunsTheBot                          #
# Note that it is not /glftpd/etc/group                      #
#                                                            #
# Do the following:                                          #
#  chmod 755 /glftpd/bin/killbin                             #
#  chmod +s /glftpd/bin/killbin                              #
#  chown root:wheel /glftpd/bin/killbin                      #
#                                                            #
# Now then. Change the settings below.                       #
#                                                            #
#-[ Settings ]-----------------------------------------------#

WHOBIN=/glftpd/bin/tur-ftpwho  # Full path to tur-ftpwho
KILLBIN=/glftpd/bin/killbin    # Full path to killbin
                               # rename it anything you want
                               # and set here what it is.

SHOWKICKS="TRUE"               # Show who we kick, etc? 
                               # TRUE/FALSE

EXCLUDE="turranius suka"       # Excluded users, space delimited.

BOLD=""                      # Dont change this one :)

## Some text for you to edit, if you have SHOWKICKS on TRUE.
## Start and stop bold with $BOLD

# Idlers kick (no argument given).
SHOWHEAD="Kicking idle user(s) $BOLD"
SHOWFOOT="$BOLD, byyye!"
SHOWNOIDLERS="No idlers online, leech later"

# User kick (argument given).
USERKICK="Username:$BOLD $1$BOLD kixxored."
NOUSERKICK="Username:$BOLD $1$BOLD was not found online."
USEREXCLUDED="$BOLD$1$BOLD is way to leet to be kicked."


#################################################
# No changes below here                         #
#################################################

if [ "$1" = "" ]; then
  SEXCLUDE="$( echo $EXCLUDE | tr -s ' ' '|' )"
  for rawdata in `$WHOBIN | grep -w "Idle:" | egrep -v "$SEXCLUDE" | tr -d ' '`; do
    user="$( echo $rawdata | awk -F"^" '{print $1}' )"
    upid="$( echo $rawdata | awk -F"^" '{print $2}' )"
    if [ "$USERS" = "" ]; then
      USERS="$user"
    else
      USERS="$USERS $user"
    fi
    if [ "$PIDS" = "" ]; then
      PIDS="$upid"
    else
      PIDS="$PIDS $upid"
    fi
  done

  if [ "$SHOWKICKS" = "TRUE" ]; then
    if [ "$USERS" = "" ]; then
      echo "$SHOWNOIDLERS"
    else
      echo "$SHOWHEAD$USERS$SHOWFOOT"
    fi
  fi

  if [ "$PIDS" != "" ]; then
    for pid in $PIDS; do
      $KILLBIN $pid
    done
  fi
fi

if [ "$1" != "" ]; then
  SEXCLUDE="$( echo $EXCLUDE | tr -s ' ' '|' )"
  CHECKEXCLUDE="$( echo "$EXCLUDE" | grep -w $1 )"
  if [ "$CHECKEXCLUDE" != "" ]; then
    echo "$USEREXCLUDED"
    exit 0
  fi
  for rawdata in `$WHOBIN | grep -w "$1" | tr -d ' '`; do
    user="$( echo $rawdata | awk -F"^" '{print $1}' )"
    upid="$( echo $rawdata | awk -F"^" '{print $2}' )"
    if [ "$PIDS" = "" ]; then
      PIDS="$upid"
    else
      PIDS="$PIDS $upid"
    fi
  done
  if [ "$SHOWKICKS" = "TRUE" ]; then
    if [ "$PIDS" = "" ]; then
      echo "$NOUSERKICK"
    else
      echo "$USERKICK"
    fi
  fi
  if [ "$PIDS" != "" ]; then
    for pid in $PIDS; do
      $KILLBIN $pid
    done
  fi
fi


